// Dynamic link library implementation of NeuroSolutions StandardFull and ConscienceFull component 

#include "NSDLL.h" 

/*************************************************************/
/* Macros to access the PE layers and weights in matrix form */

#define in(i,j)		input[j+i*inCols]
#define out(i,j)	output[j+i*outCols]
#define W(i,j)		weights[j+i*inCount]

/******************************/
/* Unsupervised weight update */

__declspec(dllexport) void performCompetitive(
	DLLData	*instance,	// Pointer to instance data (may be NULL)
	NSFloat	*input,		// Pointer to input layer 
	int 	inRows,		// Number of rows of PEs in the input layer
	int 	inCols,		// Number of columns of PEs in the input layer
	NSFloat	*output, 	// Pointer to the output layer
	int 	outRows,	// Number of rows of PEs in the output layer
	int 	outCols,	// Number of columns of PEs in the output layer
	NSFloat	*weights,	// Pointer to fully connected weight matrix 
	NSFloat	step, 		// Learning rate
	int	winner		// Index of winning PE 
	)
{
	int	i,
		inCount=inRows*inCols,
		outCount=outRows*outCols;

	for (i=0; i<inCount; i++) 
		W(winner,i) += step*(input[i] - W(winner,i));
}

/******************************************/
/* Management of instance data (OPTIONAL) */
/*
__declspec(dllexport) DLLData *allocCompetitive(
	DLLData	*oldInstance,	// Pointer to the last instance if reallocating
	int 	inRows,		// Number of rows of PEs in the input layer
	int 	inCols,		// Number of columns of PEs in the input layer
	int 	outRows,	// Number of rows of PEs in the output layer
	int 	outCols		// Number of columns of PEs in the output layer
	)
{
	DLLData *instance = allocDLLInstance(oldInstance);
	return instance;
}

__declspec(dllexport) void freeCompetitive(DLLData *instance)
{
	freeDLLInstance(instance);
}
*/